Index: ultimate_cart/veronica/FT832.v
===================================================================
--- ultimate_cart/veronica/FT832.v	(revision 684)
+++ ultimate_cart/veronica/FT832.v	(revision 685)
@@ -4216,40 +4292,26 @@
                         end
             `LOAD_2316:
                         begin
-                            b32[23:16] <= db;
-                            res32[23:16] <= db;
+                            b32[23:16] <= dati;
+                            res32[23:16] <= dati;
                             load_what <= `LOAD_3124;
                             radr <= inc_adr(radr);
-                            if (DEAD_CYCLE) begin
-                                data_nack();
-                                next_state(LOAD_MAC1);
-                            end
-                            else begin
-                                data_read(inc_adr(radr),0);
-                                if (seg_fault_val==0)
-                                    state <= LOAD_MAC2;
-                            end
+                            next_state(LOAD_MAC1);
                         end
             `LOAD_3124:
                         begin
                             radr <= inc_adr(radr);
-                            b32[31:24] <= db;
-                            res32[31:24] <= db;
+                            b32[31:24] <= dati;
+                            res32[31:24] <= dati;
                             state <= retstate;
                         end
             `WORD_71S:
                         begin
-                            res32[7:0] <= db;
+                            res32[7:0] <= dati;
                             if (s16|s32) begin
                                 load_what <= `WORD_159S;
                                 inc_sp();
-                                if (DEAD_CYCLE)
-                                    next_state(LOAD_MAC1);
-                                else begin
-                                    data_read(fn_add_to_sp(32'd1),0);
-                                    if (seg_fault_val==0)
-                                        next_state(LOAD_MAC2);
-                                end
+                                next_state(LOAD_MAC1);
                             end
                             else
                                 next_state(retstate);
@@ -4256,17 +4318,11 @@
                         end
             `WORD_159S:
                         begin
-                            res32[15:8] <= db;
+                            res32[15:8] <= dati;
                             if (s32) begin
                                 load_what <= `WORD_2317S;
                                 inc_sp();
-                                if (DEAD_CYCLE)
-                                    next_state(LOAD_MAC1);
-                                else begin
-                                    data_read(fn_add_to_sp(32'd1),0);
-                                    if (seg_fault_val==0)
-                                        next_state(LOAD_MAC2);
-                                end
+                                next_state(LOAD_MAC1);
                             end
                             else
                                 next_state(retstate);
@@ -4273,34 +4329,32 @@
                         end
             `WORD_2317S:
                         begin
-                            res32[23:16] <= db;
+                            res32[23:16] <= dati;
                             load_what <= `WORD_3125S;
                             inc_sp();
-                            if (DEAD_CYCLE)
-                                next_state(LOAD_MAC1);
-                            else begin
-                                data_read(fn_add_to_sp(32'd1),0);
-                                if (seg_fault_val==0)
-                                    next_state(LOAD_MAC2);
-                            end
+                            next_state(LOAD_MAC1);
                         end
             `WORD_3125S:
                         begin
-                            res32[31:24] <= db;
+                            res32[31:24] <= dati;
                             state <= retstate;
                         end
             `SR_70:        begin
-                            cf <= db[0];
-                            zf <= db[1];
-                            if (db[2])
+                            cf <= dati[0];
+                            zf <= dati[1];
+                            /*
+                            if (dati[2] & ~isRTI)
                                 im <= 1'b1;
-                            else
-                                imcd <= 3'b110;
-                            df <= db[3];
+                            else begin
+                                im <= 1'b0;
+                                //imcd <= 3'b110;
+                            end
+                            */
+                            df <= dati[3];
                             if (m816|m832) begin
-                                x_bit <= db[4];
-                                m_bit <= db[5];
-//                                if (db[4]) begin
+                                x_bit <= dati[4];
+                                m_bit <= dati[5];
+//                                if (dati[4]) begin
 //                                    x[31:8] <= 24'd0;
 //                                    y[31:8] <= 24'd0;
 //                                end
@@ -4307,36 +4361,24 @@
                             end
                             // The following load of the break flag is different than the '02
                             // which never loads the flag.
-                            else if (POPBF)
-                                bf <= db[4];
-                            vf <= db[6];
-                            nf <= db[7];
+                            else begin
+                                x_bit <= 1'b1;
+                                m_bit <= 1'b1;
+                                if (POPBF)
+                                    bf <= dati[4];
+                            end
+                            vf <= dati[6];
+                            nf <= dati[7];
                             if (isRTI) begin
                                 load_what <= `PC_70;
                                 inc_sp();
-                                if (DEAD_CYCLE) begin
-                                    data_nack();
-                                    next_state(LOAD_MAC1);
-                                end
-                                else begin
-                                    data_read(fn_add_to_sp(32'd1),0);
-                                    if (seg_fault_val==0)
-                                        state <= LOAD_MAC2;
-                                end
+                                next_state(LOAD_MAC1);
                             end        
                             else begin    // PLP
                                 if (m832) begin
                                     load_what <= `SR_158;
                                     inc_sp();
-                                    if (DEAD_CYCLE) begin
-                                        data_nack();
-                                        next_state(LOAD_MAC1);
-                                    end
-                                    else begin
-                                        data_read(fn_add_to_sp(32'd1),0);
-                                        if (seg_fault_val==0)
-                                            state <= LOAD_MAC2;
-                                    end
+                                    next_state(LOAD_MAC1);
                                 end
                                 else
                                     moveto_ifetch();
@@ -4344,86 +4386,76 @@
                         end
              `SR_158:
                         begin
-                            m816 <= db[0];
-                            m832 <= db[1];
-                            mib <= db[2];
-                            ssm <= db[4];
+                            m816 <= dati[0];
+                            m832 <= dati[1];
+                            mib <= dati[2];
+                            ssm <= dati[4];
                             moveto_ifetch();
                         end
 `ifdef SUPPORT_TASK
              // Vector to the task only if it's not the one currently running. 
              `LDW_TR70: begin
-                            b32 <= db;
+                            b32 <= dati;
                             radr <= inc_adr(radr);
                             load_what <= `LDW_TR158;
-                            if (DEAD_CYCLE) begin
-                                data_nack();
-                                next_state(LOAD_MAC1);
-                            end
-                            else begin
-                                data_read(inc_adr(radr),0);
-                                if (seg_fault_val==0)
-                                    next_state(LOAD_MAC2);
-                            end
+                            next_state(LOAD_MAC1);
                         end
              `LDW_TR158: begin
                            radr <= inc_adr(radr);
                            vpb <= FALSE;
-                           if ({db,b32[7:0]} != tr) begin
-                               set_task_regs(hwi ? 24'd0 : 24'd2);
-                               tr <= {db,b32[7:0]};
-                               back_link <= tr;
-                               tsk_pres <= 7'h20;
-                               state <= TSK1;
-`ifdef TASK_BL
-                               retstate <= IFETCH;
-`else                               
-                               store_what <= `STW_TR158;
-                               retstate <= STORE1;
-`endif
+                           if (dati[7:1]==7'b0) begin
+                               ima[3] <= 1'b1;
+                               its <= 1'b1;
+                               if ({dati[`TASK_MEM_ABIT-8-3:0],b32[7:0]} != tr) begin
+                                   set_task_regs(hwi ? 24'd0 : 24'd2);
+                                   tr <= {dati,b32[7:0]};
+                                   back_link <= tr;
+                                   tsk_pres <= PRES_BACKLINK;
+                                   state <= TSK1;
+                                   store_what <= `STW_TR158;
+                                   retstate <= STORE1;
+                               end
+                               else begin
+                                   next_state(IFETCH);
+                               end
                            end
                            else begin
-                               next_state(IFETCH);
+                               its <= 1'b0;
+                               ima[3] <= 1'b0;
+                               temp_vec <= {dati,b32[7:0]};
+                               set_sp();
+`ifdef SUPPORT_SEG                    
+                               seg <= ss_base;
+                               lmt <= ss_limit;
+                               mem_wr <= ss_wr;
+`endif                    
+                               store_what <= `SUPPORT_SEG ? `STW_CS158 : `STW_PC2316;
+                               data_nack();
+                               state <= STORE1;
                            end
                         end
-`ifndef TASK_BL
              `LDW_TR70S:
                         begin
-                           tr[7:0] <= db;
+                           trh <= dati;
                            load_what <= `LDW_TR158S;
                            inc_sp();
-                           if (DEAD_CYCLE) begin
-                               data_nack();
-                               next_state(LOAD_MAC1);
-                           end
-                           else begin
-                               data_read(fn_add_to_sp(32'd1),0);
-                                if (seg_fault_val==0)
-                                   state <= LOAD_MAC2;
-                           end
+                           next_state(LOAD_MAC1);
                         end
              `LDW_TR158S:
                        begin
-                          tr[`TASK_MEM_ABIT:8] <= db;
+                          tr[`TASK_MEM_ABIT-3:0] <= {dati,trh[7:0]};
                           next_state(TSK1);
-                          retstate <= ssm ? SSM1 : IFETCH;
+                          retstate <= ssm ? SSM1 : IFETCH;  // ??? should assign in TSK1 ?
                        end
 `endif
-`endif
              `PC_70:        begin
-                            pc[7:0] <= db;
+                            if (ir[7:0]==`BRK && hwi)
+                                iml <= iml1;
+                            pc[7:0] <= dati;
                             load_what <= `PC_158;
                             if (isRTI|isRTS|isRTL|isRTF) begin
                                 inc_sp();
-                                if (DEAD_CYCLE) begin
-                                    data_nack();
-                                    next_state(LOAD_MAC1);
-                                end
-                                else begin
-                                    data_read(fn_add_to_sp(32'd1),0);
-                                    if (seg_fault_val==0)
-                                        state <= LOAD_MAC2;
-                                end
+                                next_state(LOAD_MAC1);
                             end
                             else begin    // JMP (abs)
                                 radr <= inc_adr(radr);
@@ -4431,52 +4463,48 @@
                             end
                         end
             `PC_158:    begin
-                            pc[15:8] <= db;
-                            if ((isRTI&(m816|m832))|isRTL|isRTF) begin
+                            pc[15:8] <= dati;
+                            if (isJmpi|isJsrIndx)
+                                moveto_ifetch();
+                            else if (isRTI|isRTL|isRTF) begin
                                 load_what <= `PC_2316;
                                 inc_sp();
-                                if (DEAD_CYCLE) begin
-                                    data_nack();
-                                    next_state(LOAD_MAC1);
-                                end
-                                else begin
-                                    data_read(fn_add_to_sp(32'd1),0);
-                                    if (seg_fault_val==0)
-                                        state <= LOAD_MAC2;
-                                end
+                                next_state(LOAD_MAC1);
                             end
                             else if (isRTS) begin   // rts instruction
+`ifdef SUPPORT_SEG                            
                                 sdt_ra <= cs;
+`endif                                
                                 next_state(RTS1);
                             end
                             else if (isJLInd) begin   // jmp (abs)
                                 load_what <= `PC_2316;
+`ifdef SUPPORT_SEG                                
                                 seg <= ds_base;
                                 lmt <= ds_limit;
                                 mem_wr <= ds_wr;
+`endif                                
                                 radr <= inc_adr(radr);
                                 state <= LOAD_MAC1;
                             end
-                            else
-                            begin
-                                vpb <= `FALSE;
+                            else if (isRstVect) begin
+                                isRstVect <= `FALSE;
                                 next_state(IFETCH);
                             end
+                            else begin   // brk
+                                vpb <= `FALSE;
+                                pc[23:16] <= 8'h00;
+                                cs <= 16'h0000;
+                                sdt_ra <= 12'h000;
+                                next_state(JMF1);
+                            end
                         end
             `PC_2316:    begin
-                            pc[23:16] <= db;
-                            if (isRTF|(isRTI&m832)) begin
+                            pc[23:16] <= dati;
+                            if (isRTF|isRTI) begin
                                 load_what <= `CS_70;
                                 inc_sp();
-                                if (DEAD_CYCLE) begin
-                                    data_nack();
-                                    next_state(LOAD_MAC1);
-                                end
-                                else begin
-                                    data_read(fn_add_to_sp(32'd1),0);
-                                    if (seg_fault_val==0)
-                                        next_state(LOAD_MAC2);
-                                end
+                                next_state(LOAD_MAC1);
                             end
                             else if (isRTL) begin
                                 load_what <= `NOTHING;
@@ -4485,7 +4513,7 @@
                             end
                             else begin
                                 load_what <= `NOTHING;
-                                next_state(IFETCH);
+                                next_state((pc[23:16]!=dati)?PBDELAY:IFETCH);
                             end
                         end
 `ifdef SUPPORT_SEG
@@ -4492,20 +4520,13 @@
               `CS_70:   begin
                               load_what <= `CS_158;
                               inc_sp();
-                              cs[7:0] <= db;
-                              if (DEAD_CYCLE) begin
-                                  data_nack();
-                                  next_state(LOAD_MAC1);
-                              end
-                              else begin
-                                  data_read(fn_add_to_sp(32'd1),0);
-                                  if (seg_fault_val==0)
-                                      next_state(LOAD_MAC2);
-                              end
+                              cs[7:0] <= dati;
+                              //mapno <= dati[5:0];
+                              next_state(LOAD_MAC1);
                         end
               `CS_158:   begin
-                            cs[15:8] <= db;
-                            sdt_ra <= {db,cs[7:0]};
+                            cs[15:8] <= dati;
+                            sdt_ra <= {dati,cs[7:0]};
                             if (isRTF)
                                 next_state(RTS1);
                             else
@@ -4513,86 +4534,99 @@
                         end
 `endif
         //    `PC_3124:    begin
-        //                    pc[31:24] <= db;
+        //                    pc[31:24] <= dati;
         //                    load_what <= `NOTHING;
         //                    next_state(BYTE_IFETCH);
         //                end
             `IA_70:
                     begin
-                        radr <= radr + 32'd1;
-                        if (DEAD_CYCLE) begin
-                            data_nack();
-                            next_state(LOAD_MAC1);
-                        end
-                        else begin
-                            data_read(radr + 32'd1,0);
-                            if (seg_fault_val==0)
-                                state <= LOAD_MAC2;
-                        end
-                        ia[7:0] <= db;
+                        radr <= inc_adr(radr);
+                        next_state(LOAD_MAC1);
+                        ia[7:0] <= dati;
                         load_what <= `IA_158;
                     end
             `IA_158:
                     begin
-                        ia[15:8] <= db;
+                        radr <= inc_adr(radr);
+                        ia[15:8] <= dati;
                         ia[23:16] <= dbr;
                         ia[31:24] <= 8'h00;
                         if (isIY24|isI24|isIY32|isI32) begin
-                            radr <= radr + 32'd1;
-                            if (DEAD_CYCLE) begin
-                                data_nack();
+                            next_state(LOAD_MAC1);
+                            load_what <= `IA_2316;
+                        end
+                        else begin
+`ifdef SUPPORT_SEG          
+                            if (isFar) begin
+                                load_what <= `LDW_SEG70;
                                 next_state(LOAD_MAC1);
                             end
                             else begin
-                                data_read(radr + 32'd1,0);
-                                if (seg_fault_val==0)
-                                    state <= LOAD_MAC2;
-                            end
-                            load_what <= `IA_2316;
-                        end
-                        else begin
-                            seg <= ds_base;
-                            lmt <= ds_limit;
-                            mem_wr <= ds_wr;
+                                sdt_ra <= ds;
+                                state <= isIY ? BYTE_IY5 : BYTE_IX5;
+                            end              
+`else                            
                             state <= isIY ? BYTE_IY5 : BYTE_IX5;
+`endif                               
                         end
                     end
             `IA_2316:
                     begin
-                        ia[23:16] <= db;
+                        radr <= inc_adr(radr);
+                        ia[23:16] <= dati;
                         ia[31:24] <= 8'h00;
                         if (isI32|isIY32) begin
                             load_what <= `IA_3124;
-                            radr <= radr + 32'd1;
-                            if (DEAD_CYCLE) begin
-                                data_nack();
+                            next_state(LOAD_MAC1);
+                        end
+                        else begin
+`ifdef SUPPORT_SEG                        
+                            if (isFar) begin
+                                load_what <= `LDW_SEG70;
                                 next_state(LOAD_MAC1);
                             end
                             else begin
-                                data_read(radr + 32'd1,0);
-                                if (seg_fault_val==0)
-                                    next_state(LOAD_MAC2);
+                                sdt_ra <= ds;
+                                state <= isIY24 ? BYTE_IY5 : BYTE_IX5;
                             end
-                        end
-                        else begin
-                            seg <= ds_base;
-                            lmt <= ds_limit;
-                            mem_wr <= ds_wr;
+`else                            
                             state <= isIY24 ? BYTE_IY5 : BYTE_IX5;
+`endif                            
                         end
                     end
             `IA_3124:
                     begin
-                        ia[31:24] <= db;
-                        seg <= ds_base;
-                        lmt <= ds_limit;
-                        mem_wr <= ds_wr;
+                        radr <= inc_adr(radr);
+                        ia[31:24] <= dati;
+`ifdef SUPPORT_SEG
+                        if (isFar) begin
+                            load_what <= `LDW_SEG70;
+                            next_state(LOAD_MAC1);
+                        end
+                        else begin
+                            sdt_ra <= ds;
+                            state <= isIY32 ? BYTE_IY5 : BYTE_IX5;
+                        end
+`else                        
                         state <= isIY32 ? BYTE_IY5 : BYTE_IX5;
+`endif
                     end
+            `LDW_SEG70:
+                    begin
+                        load_what <= `LDW_SEG158;
+                        radr <= inc_adr(radr);
+                        sdt_ra[7:0] <= dati;
+                        next_state(LOAD_MAC1);
+                    end
+            `LDW_SEG158:
+                    begin
+                        sdt_ra[11:8] <= dati[3:0];
+                        state <= isIY|isIY24|isIY32 ? BYTE_IY5 : BYTE_IX5;
+                    end
             endcase
         end
         //endtask
-//        load_tsk(db,b16);
+//        load_tsk(dati,b16);
     end
 `ifdef SUPPORT_BERR
     else if (err_i) begin
@@ -4610,6 +4644,7 @@
         inc_pc(24'd1);
         cs_base <= base_o;
         cs_limit <= fn_limit(size_o);
+        cs_wr <= acr_o[3];
         moveto_ifetch();
     end
 BYTE_IX5:
@@ -4618,9 +4653,11 @@
         isI32 <= `FALSE;
         bank_wrap <= FALSE;
         page_wrap <= FALSE;
-        seg <= ds_base;
-        lmt <= ds_limit;
-        mem_wr <= ds_wr;
+`ifdef SUPPORT_SEG
+        seg <= base_o;
+        lmt <= fn_limit(size_o);
+        mem_wr <= acr_o[3];
+`endif
         radr <= ia;
         load_what <= `LOAD_70;
         state <= LOAD_MAC1;
@@ -4628,7 +4665,7 @@
             if (m32) s32 <= TRUE;
             else if (m16) s16 <= TRUE;
         end
-        if (ir[7:0]==`STA_IX || ir[7:0]==`STA_I || ir[7:0]==`STA_IL) begin
+        if (ir[7:0]==`STA_IX || ir[7:0]==`STA_I || ir[7:0]==`STA_IL || ir[7:0]==`STA_XIL) begin
             wadr <= ia;
             store_what <= `STW_ACC70;
             state <= STORE1;
@@ -4637,6 +4674,7 @@
             set_sp();
             seg <= ss_base;
             lmt <= ss_limit;
+            mem_wr <= ss_wr;
             store_what <= isI32 ? `STW_IA3124 : `STW_IA158;
             state <= STORE1;
         end
@@ -4648,9 +4686,11 @@
         isIY32 <= `FALSE;
         bank_wrap <= FALSE;
         page_wrap <= FALSE;
-        seg <= ds_base;
-        lmt <= ds_limit;
-        mem_wr <= ds_wr;
+`ifdef SUPPORT_SEG
+        seg <= base_o;
+        lmt <= fn_limit(size_o);
+        mem_wr <= acr_o[3];
+`endif
         radr <= iapy8;
         wadr <= iapy8;
         if (!sop) begin
@@ -4660,6 +4700,7 @@
         store_what <= `STW_ACC70;
         load_what <= `LOAD_70;
         $display("IY addr: %h", iapy8);
+        // Testing only ir[7:0] below will take care of 'X' forms as well.
         if (ir[7:0]==`STA_IY || ir[7:0]==`STA_IYL || ir[7:0]==`STA_DSPIY)
             state <= STORE1;
         else
@@ -4712,7 +4753,7 @@
 		`STW_IA158:		begin data_write(wadr,ia[15:8],0); mlb <= 1'b1; end
 		`STW_IA70:		data_write(wadr,ia,0);
 `ifdef SUPPORT_TASK
-        `STW_TR158:     begin data_write(wadr,otr[`TASK_MEM_ABIT:8],1); mlb <= 1'b1; end
+        `STW_TR158:     begin data_write(wadr,otr[`TASK_MEM_ABIT-3:8],1); mlb <= 1'b1; end
         `STW_TR70:      data_write(wadr,otr[7:0],0);
 		`STW_CPY_BUF:   begin data_write(wadr,cpybuf[cnt],0); mlb <= maxcnt > 8'd1; end
 `endif
@@ -4728,7 +4769,7 @@
 // Terminal state for stores. Update the data cache if there was a cache hit.
 // Clear any previously set lock status
 STORE2:
-	if (rdy) begin
+	if (irdy) begin
 //		wdat <= dat_o;
 		mlb <= 1'b0;
 		data_nack();
@@ -4759,15 +4800,7 @@
 		            mlb <= TRUE;
 		            cnt <= cnt - 8'd1;
                     set_sp();
-                    if (DEAD_CYCLE) begin
-                        data_nack();
-                        next_state(STORE1);
-                    end
-                    else begin
-                        data_write(fn_get_sp(sp),cpybuf[cnt-8'd1],0);
-                        if (seg_fault_val==0)
-                            state <= STORE2;
-                    end
+                    next_state(STORE1);
 		        end
 		        else begin
 `ifdef TASK_BL
@@ -4778,13 +4811,7 @@
 		            else begin
     		            store_what <= `STW_TR158;
     		            set_sp();
-                        if (DEAD_CYCLE)
-                            next_state(STORE1);
-                        else begin
-                            data_write(fn_get_sp(sp),otr[`TASK_MEM_ABIT:8],0);
-                            if (seg_fault_val==0)
-                                next_state(STORE2);
-    		            end
+                        next_state(STORE1);
 		            end
 `endif
 		        end
@@ -4795,13 +4822,7 @@
 				if (s16|s32) begin
 				    mlb <= TRUE;
                     store_what <= `STW_DEF158;
-                    if (DEAD_CYCLE)
-                        next_state(STORE1);
-                    else begin
-		                data_write(inc_adr(wadr),wdat[15:8],0);
-                        if (seg_fault_val==0)
-                            next_state(STORE2);
-                    end
+                    next_state(STORE1);
                 end
 			end
 		`STW_DEF158:
@@ -4808,13 +4829,7 @@
 			if (s32) begin
 			    mlb <= TRUE;
 				wadr <= inc_adr(wadr);
-				if (DEAD_CYCLE)
-				    next_state(STORE1);
-				else begin
-                    data_write(inc_adr(wadr),wdat[23:16],0);
-                    if (seg_fault_val==0)
-                        next_state(STORE2);
-                end
+    		    next_state(STORE1);
 				store_what <= `STW_DEF2316;
 			end
 		`STW_DEF2316:
@@ -4821,15 +4836,7 @@
             begin
 			    mlb <= TRUE;
 				wadr <= inc_adr(wadr);
-				if (DEAD_CYCLE) begin
-                    data_nack();
-				    next_state(STORE1);
-				end
-				else begin
-	                data_write(inc_adr(wadr),wdat[31:24],0);
-                    if (seg_fault_val==0)
-                        next_state(STORE2);
-	            end
+    		    next_state(STORE1);
                 store_what <= `STW_DEF3124;
             end
         `STW_ACC70:
@@ -4837,15 +4844,7 @@
 				wadr <= inc_adr(wadr);
 			    mlb <= TRUE;
                 store_what <= `STW_ACC158;
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-		            data_write(inc_adr(wadr),acc[15:8],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
             end
         `STW_ACC158:
             if (s32) begin
@@ -4852,15 +4851,7 @@
                 wadr <= inc_adr(wadr);
 			    mlb <= TRUE;
                 store_what <= `STW_ACC2316;
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-		            data_write(inc_adr(wadr),acc[23:16],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
             end
         `STW_ACC2316:
             begin
@@ -4867,15 +4858,7 @@
                 wadr <= inc_adr(wadr);
 			    mlb <= TRUE;
                 store_what <= `STW_ACC3124;
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-		            data_write(inc_adr(wadr),acc[31:24],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
             end
 		`STW_X70:
 		    begin
